<template>

  <n-button color="#f0f0ff" text-color="#4a4cd9" size="small" round @click="handleAddTable">
    <icon-ic-round-plus class="mr-4px text-16px" />
      New
  </n-button>
  <table-action-modal v-model:visible="visible" :type="modalType" :edit-data="editData" />
</template>

<!-- import { views } from '~/src/views';
<script setup lang="tsx">
import { reactive, ref } from 'vue';
import type { Ref } from 'vue';
import { useBoolean } from '@/hooks';
import type { ModalType } from '~/src/views/management/user/components/table-action-modal.vue';
// const { loading, startLoading, endLoading } = useLoading(false);
const { setTrue: openModal } = useBoolean();
defineOptions({ name: 'GlobalButton' });
function handleAddNew() {
  openModal();
  console.log("AddNew");
}
</script>-->

<script setup lang="tsx">
import { ref } from 'vue';
import { NButton} from 'naive-ui';
import { fetchUserList } from '@/service';
import { useBoolean, useLoading } from '@/hooks';
// import TableActionModal from '~/src/views/management/user/components/table-action-modal.vue';
import TableActionModal from '~/src/views/admin-center/general/user-account/components/table-action-modal.vue';
// import type { ModalType } from './components/table-action-modal.vue';
// import type { ModalType } from '~/src/views/management/user/components/table-action-modal.vue';
import type { ModalType } from '~/src/views/admin-center/general/user-account/components/table-action-modal.vue'
// import ColumnSetting from './components/column-setting.vue';
defineOptions({ name: 'GlobalButton' });
const { startLoading, endLoading } = useLoading(false);
const { bool: visible, setTrue: openModal } = useBoolean();

const tableData = ref<UserManagement.User[]>([]);
function setTableData(data: UserManagement.User[]) {
  tableData.value = data;
}

async function getTableData() {
  startLoading();
  const { data } = await fetchUserList();
  if (data) {
    setTimeout(() => {
      setTableData(data);
      endLoading();
    }, 1000);
  }
}

// const columns: Ref<DataTableColumns<UserManagement.User>> = ref([
//   {
//     type: 'selection',
//     align: 'center'
//   },
//   {
//     key: 'index',
//     title: '序号',
//     align: 'center'
//   },
//   {
//     key: 'userName',
//     title: '用户名',
//     align: 'center'
//   },
//   {
//     key: 'age',
//     title: '用户年龄',
//     align: 'center'
//   },
//   {
//     key: 'gender',
//     title: '性别',
//     align: 'center',
//     render: row => {
//       if (row.gender) {
//         const tagTypes: Record<UserManagement.GenderKey, NaiveUI.ThemeColor> = {
//           '0': 'success',
//           '1': 'warning'
//         };

//         return <NTag type={tagTypes[row.gender]}>{genderLabels[row.gender]}</NTag>;
//       }

//       return <span></span>;
//     }
//   },
//   {
//     key: 'phone',
//     title: '手机号码',
//     align: 'center'
//   },
//   {
//     key: 'email',
//     title: '邮箱',
//     align: 'center'
//   },
//   {
//     key: 'userStatus',
//     title: '状态',
//     align: 'center',
//     render: row => {
//       if (row.userStatus) {
//         const tagTypes: Record<UserManagement.UserStatusKey, NaiveUI.ThemeColor> = {
//           '1': 'success',
//           '2': 'error',
//           '3': 'warning',
//           '4': 'default'
//         };

//         return <NTag type={tagTypes[row.userStatus]}>{userStatusLabels[row.userStatus]}</NTag>;
//       }
//       return <span></span>;
//     }
//   },
//   {
//     key: 'actions',
//     title: '操作',
//     align: 'center',
//     render: row => {
//       return (
//         <NSpace justify={'center'}>
//           <NButton size={'small'} onClick={() => handleEditTable(row.id)}>
//             编辑
//           </NButton>
//           <NPopconfirm onPositiveClick={() => handleDeleteTable(row.id)}>
//             {{
//               default: () => '确认删除',
//               trigger: () => <NButton size={'small'}>删除</NButton>
//             }}
//           </NPopconfirm>
//         </NSpace>
//       );
//     }
//   }
// ]) as Ref<DataTableColumns<UserManagement.User>>;

const modalType = ref<ModalType>('add');

function setModalType(type: ModalType) {
  modalType.value = type;
}

const editData = ref<UserManagement.User | null>(null);

// function setEditData(data: UserManagement.User | null) {
//   editData.value = data;
// }

function handleAddTable() {
  openModal();
  setModalType('add');  
}

// function handleEditTable(rowId: string) {
//   const findItem = tableData.value.find(item => item.id === rowId);
//   if (findItem) {
//     setEditData(findItem);
//   }
//   setModalType('edit');
//   openModal();
// }

// function handleDeleteTable(rowId: string) {
//   window.$message?.info(`点击了删除，rowId为${rowId}`);
// }

function init() {
  getTableData();
}

// 初始化
init();
</script>

<style scoped></style>
